<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Robert Detjens">
  <meta name="author" content="OSU LUG">
  <title>Pimp Your Shell</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reset.css">
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/reveal.css">
  <style>
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
    .display.math{display: block; text-align: center; margin: 0.5rem auto;}
  </style>
  <link rel="stylesheet" href="https://unpkg.com/reveal.js@^4//dist/theme/black.css" id="theme">
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">Pimp Your Shell</h1>
  <p class="author">Robert Detjens</p>
  <p class="author">OSU LUG</p>
  <p class="date">2/8/22</p>
</section>

<section>
<section id="default-shell" class="title-slide slide level1">
<h1>Default Shell</h1>
<p>Usually boring.</p>
<figure>
<img data-src="images/centos8.png" alt="CentOS :ResidentSleeper:" /><figcaption aria-hidden="true">CentOS :ResidentSleeper:</figcaption>
</figure>
</section>
<section class="slide level2">

<p>Debian/etc at least has some color</p>
<p>and real basic tab completion</p>
<p><img data-src="images/debian11.png" /></p>
<p><img data-src="images/ubuntu.png" /></p>
</section></section>
<section id="we-can-do-better" class="title-slide slide level1">
<h1>We can do better</h1>
<p>Its 2022, make your shell pop!</p>
<p><img data-src="images/ls-cat.png" /></p>
</section>

<section>
<section id="how" class="title-slide slide level1">
<h1>How?</h1>
<p>stock coreutils are so 1976</p>
<ul>
<li><code>ls</code> -&gt; <strong><code>lsd</code></strong> (or <code>colorls</code> or <code>exa</code>)</li>
<li><code>cat</code> -&gt; <strong><code>bat</code></strong></li>
<li><code>diff</code> -&gt; <strong><code>delta</code></strong></li>
<li><code>find</code> -&gt; <strong><code>fd</code></strong></li>
<li><strong><code>fzf</code></strong></li>
</ul>
<p>don’t forget the shell either</p>
<div class="columns">
<div class="column">
<p>Bash:</p>
<ul>
<li>custom <code>$PS1</code></li>
<li><code>bashgit</code></li>
</ul>
</div><div class="column">
<p>ZSH:</p>
<ul>
<li>themes</li>
<li>plugins</li>
</ul>
</div>
</div>
</section>
<section id="lsd" class="slide level2">
<h2>lsd</h2>
<p><code>lsd</code> is a “next gen ls command”: <a href="https://github.com/Peltoche/lsd" class="uri">https://github.com/Peltoche/lsd</a></p>
<p><img data-src="images/lsd.png" /></p>
<p>icons, colors, sizes, <code>--tree</code></p>
</section>
<section id="bat" class="slide level2">
<h2>bat</h2>
<p><code>cat</code> on steroids: <a href="https://github.com/sharkdp/bat" class="uri">https://github.com/sharkdp/bat</a></p>
<p>syntax highlighting, paging, git integration</p>
<p><img data-src="https://camo.githubusercontent.com/7b7c397acc5b91b4c4cf7756015185fe3c5f700f70d256a212de51294a0cf673/68747470733a2f2f696d6775722e636f6d2f724773646e44652e706e67" /></p>
<p><code>alias cat='bat -pp'</code></p>
</section>
<section id="delta" class="slide level2">
<h2>delta</h2>
<p><code>diff</code>, but better: <a href="https://github.com/dandavison/delta" class="uri">https://github.com/dandavison/delta</a></p>
<p>better color, context, highlighting</p>
<p><img data-src="images/delta.png" /></p>
</section>
<section id="fzf" class="slide level2">
<h2>fzf</h2>
<p>find everything super fast with fuzzy search: <a href="https://gi--+thub.com/junegunn/fzf" class="uri">https://gi--+thub.com/junegunn/fzf</a></p>
<p>has shell bindings for <code>^T</code> and <code>^R</code></p>
<p><img data-src="images/fzfcd.png" /> <img data-src="images/fzfhist.png" /></p>
</section></section>
<section>
<section id="bash-customization" class="title-slide slide level1">
<h1>Bash customization</h1>
<p>not too much here that I’ve seen, but there is some!</p>
</section>
<section id="custom-ps1" class="slide level2">
<h2>Custom PS1</h2>
<p><code>$PS1</code> is what tells the shell how to make the prompt</p>
<p>builder sites: <a href="https://bashrcgenerator.com/" class="uri">https://bashrcgenerator.com/</a>, <a href="https://ezprompt.net/" class="uri">https://ezprompt.net/</a></p>
<p><img data-src="images/bashps1.png" /></p>
</section>
<section id="bashgit" class="slide level2">
<h2>Bashgit</h2>
<p>Shows the current branch &amp; status in the prompt: <a href="https://github.com/oyvindstegard/bashgit" class="uri">https://github.com/oyvindstegard/bashgit</a></p>
<p><img data-src="images/bashgit.png" /></p>
<p>just source it in your <code>~/.bashrc</code></p>
</section></section>
<section>
<section id="zsh" class="title-slide slide level1">
<h1>Zsh</h1>
<p><img data-src="images/zsh.png" /></p>
</section>
<section id="plugins" class="slide level2">
<h2>Plugins</h2>
<p>Oh-My-Zsh <a href="https://github.com/ohmyzsh/ohmyzsh" class="uri">https://github.com/ohmyzsh/ohmyzsh</a></p>
<p>Big plugin and theme collection, easy to install and use</p>
<p>but: can be kinda cumbersome to use outside plugins</p>
</section>
<section id="plugin-managers" class="slide level2">
<h2>Plugin Managers</h2>
<p>Faster and more flexible than just OMZ</p>
<ul>
<li><strong>Antigen</strong> (the incumbent) <a href="https://github.com/zsh-users/antigen" class="uri">https://github.com/zsh-users/antigen</a>
<ul>
<li>fast, zsh-native, been around for years</li>
</ul></li>
<li><strong>Sheldon</strong> (what I use) <a href="https://github.com/rossmacarthur/sheldon" class="uri">https://github.com/rossmacarthur/sheldon</a>
<ul>
<li>super fast, in Rust, uncluttered zshrc</li>
</ul></li>
</ul>
</section>
<section id="themes" class="slide level2">
<h2>Themes</h2>
<p>p10k is king</p>
<p>colors, multiline, git status, env description</p>
<p><a href="https://github.com/romkatv/powerlevel10k" class="uri">https://github.com/romkatv/powerlevel10k</a></p>
<p><img data-src="images/zsh.png" /></p>
</section>
<section id="my-plugintheme-recs" class="slide level2">
<h2>My plugin/theme recs:</h2>
<ul>
<li><code>ael-code/zsh-colored-man-pages</code></li>
<li><code>MichaelAquilina/zsh-autoswitch-virtualenv</code></li>
<li><code>zdharma-continuum/fast-syntax-highlighting</code></li>
<li><code>zsh-users/zsh-autosuggestions</code></li>
<li><code>zsh-users/zsh-completions</code></li>
<li><code>zsh-users/zsh-history-substring-search</code></li>
<li><code>romkatv/powerlevel10k</code></li>
<li><code>ohmyzsh/ohmyzsh</code> -&gt; <code>fzf</code></li>
</ul>
</section></section>
    </div>
  </div>

  <script src="https://unpkg.com/reveal.js@^4//dist/reveal.js"></script>

  <!-- reveal.js plugins -->
  <script src="https://unpkg.com/reveal.js@^4//plugin/notes/notes.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/search/search.js"></script>
  <script src="https://unpkg.com/reveal.js@^4//plugin/zoom/zoom.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://revealjs.com/config/
      Reveal.initialize({
        // Display controls in the bottom right corner
        controls: false,

        // Help the user learn the controls by providing hints, for example by
        // bouncing the down arrow when they first encounter a vertical slide
        controlsTutorial: true,

        // Determines where controls appear, "edges" or "bottom-right"
        controlsLayout: 'bottom-right',

        // Visibility rule for backwards navigation arrows; "faded", "hidden"
        // or "visible"
        controlsBackArrows: 'faded',

        // Display a presentation progress bar
        progress: true,

        // Display the page number of the current slide
        slideNumber: false,

        // 'all', 'print', or 'speaker'
        showSlideNumber: 'all',

        // Add the current slide number to the URL hash so that reloading the
        // page/copying the URL will return you to the same slide
        hash: true,

        // Start with 1 for the hash rather than 0
        hashOneBasedIndex: false,

        // Flags if we should monitor the hash and change slides accordingly
        respondToHashChanges: true,

        // Push each slide change to the browser history
        history: false,

        // Enable keyboard shortcuts for navigation
        keyboard: true,

        // Enable the slide overview mode
        overview: true,

        // Disables the default reveal.js slide layout (scaling and centering)
        // so that you can use custom CSS layout
        disableLayout: false,

        // Vertical centering of slides
        center: true,

        // Enables touch navigation on devices with touch input
        touch: true,

        // Loop the presentation
        loop: false,

        // Change the presentation direction to be RTL
        rtl: false,

        // see https://revealjs.com/vertical-slides/#navigation-mode
        navigationMode: 'default',

        // Randomizes the order of slides each time the presentation loads
        shuffle: false,

        // Turns fragments on and off globally
        fragments: true,

        // Flags whether to include the current fragment in the URL,
        // so that reloading brings you to the same fragment position
        fragmentInURL: true,

        // Flags if the presentation is running in an embedded mode,
        // i.e. contained within a limited portion of the screen
        embedded: false,

        // Flags if we should show a help overlay when the questionmark
        // key is pressed
        help: true,

        // Flags if it should be possible to pause the presentation (blackout)
        pause: true,

        // Flags if speaker notes should be visible to all viewers
        showNotes: false,

        // Global override for autoplaying embedded media (null/true/false)
        autoPlayMedia: null,

        // Global override for preloading lazy-loaded iframes (null/true/false)
        preloadIframes: null,

        // Number of milliseconds between automatically proceeding to the
        // next slide, disabled when set to 0, this value can be overwritten
        // by using a data-autoslide attribute on your slides
        autoSlide: 0,

        // Stop auto-sliding after user input
        autoSlideStoppable: true,

        // Use this method for navigation when auto-sliding
        autoSlideMethod: null,

        // Specify the average time in seconds that you think you will spend
        // presenting each slide. This is used to show a pacing timer in the
        // speaker view
        defaultTiming: null,

        // Enable slide navigation via mouse wheel
        mouseWheel: false,

        // The display mode that will be used to show slides
        display: 'block',

        // Hide cursor if inactive
        hideInactiveCursor: true,

        // Time before the cursor is hidden (in ms)
        hideCursorTime: 5000,

        // Opens links in an iframe preview overlay
        previewLinks: false,

        // Transition style (none/fade/slide/convex/concave/zoom)
        transition: 'slide',

        // Transition speed (default/fast/slow)
        transitionSpeed: 'default',

        // Transition style for full page slide backgrounds
        // (none/fade/slide/convex/concave/zoom)
        backgroundTransition: 'fade',

        // Number of slides away from the current that are visible
        viewDistance: 3,

        // Number of slides away from the current that are visible on mobile
        // devices. It is advisable to set this to a lower number than
        // viewDistance in order to save resources.
        mobileViewDistance: 2,

        // The "normal" size of the presentation, aspect ratio will be preserved
        // when the presentation is scaled to fit different resolutions. Can be
        // specified using percentage units.
        width: 1600,

        height: 900,

        // reveal.js plugins
        plugins: [
          RevealNotes,
          RevealSearch,
          RevealZoom
        ]
      });
    </script>
    </body>
</html>
